#!/usr/bin/env python
# coding: utf-8

# In[72]:


def nested_loops(depth, n):
    if depth == 0:
        yield []
    else:
        for i in range(0, n):
            for j in nested_loops(depth - 1, n):
                yield [i,] + j


# In[41]:


model = [ #Write the multiplication table of the finite model here
          [ 3, 1, 4, 0, 6, 2, 5],
          [ 0, 3, 5, 1, 2, 6, 4],
          [ 5, 4, 3, 2, 0, 1, 6],
          [ 1, 0, 6, 3, 5, 4, 2],
          [ 2, 6, 1, 4, 3, 5, 0],
          [ 6, 2, 0, 5, 4, 3, 1],
          [ 4, 5, 2, 6, 1, 0, 3]
        ]  


# In[16]:


def prod(x,y):
    return model[x][y]


# In[88]:


numvars = 3 #Number of variables, up to 4 (x,y,z,w)
def identityleft(args):
    var = args.copy()
    try: x = var.pop(0)
    except: None
    try: y = var.pop(0)
    except: None
    try: z = var.pop(0)
    except: None
    try: w = var.pop(0)
    except: None
    return prod(prod(x,z),prod(y,z)) #Write LHS of the identity here

def identityright(args):
    var = args.copy()
    try: x = var.pop(0)
    except: None
    try: y = var.pop(0)
    except: None
    try: z = var.pop(0)
    except: None
    try: w = var.pop(0)
    except: None
    return prod(x,y)  #Write RHS of the identity here


# In[91]:


def checkidentity(model, returnall=False):
    size=len(model)
    checked=True
    if returnall: counterexamples=[]
    for var in nested_loops(numvars,size):
        if identityleft(var) != identityright(var):
            if returnall:
                counterexamples.append(var)
            else:
                checked=False
                break                   
    if not returnall: return checked
    else: return counterexamples


# In[92]:


checkidentity(model,True)


# In[ ]:


identity

